#include <iostream>
#include <vector>
#include <algorithm>

#define indm (1<<18)

using namespace std;

int n,m;

struct ger
{
	int b,e;
};
vector <ger> mas;

int tr[(indm+1)];

bool operator<(const ger &x,const ger &y)
{
	if(x.b<y.b) return 1;
	if(x.b==y.b&&x.e<y.e) return 1;
	return 0;
}

void read()
{
	ger p;
	scanf("%d %d",&n,&m);
	for(int i=0;i<m;i++)
		{scanf("%d %d",&p.b,&p.e);mas.push_back(p);}
	sort(mas.begin(),mas.end());
}

void pusht(int pl,int val)
{ 
	while(pl<=indm)
	{
		tr[pl]+=val;
		pl+=(pl&(-pl));
	}
}

int qrr(int pl)
{
	int ret=0;
	while(pl)
	{
		ret+=tr[pl];
		pl-=(pl&(-pl));
	}
	return ret;
}

void solve()
{
	long long ans=0;
	int beg=0;
	int q;
	for(int i=1;i<m;i++)
	{
		if(mas[i].b==mas[i-1].b)
		{
			q=qrr(mas[i].e-1)-qrr(mas[i].b);
			ans+=q;
		}
		else
		{
			for(int j=beg;j<i;j++)
			{
				pusht(mas[j].e,1);
			}
			beg=i;
			q=qrr(mas[i].e-1)-qrr(mas[i].b);
			ans+=q;
		}
	}
	for(int j=beg;j<m;j++)
	{
		pusht(mas[j].e,1);
	}
	cout<<ans<<endl;
}

int main()
{
	read();
	solve();
	return 0;
}
