#include <iostream>
#include <cstring>

using namespace std;

char ac[5][5][5],bc[5][5][5];

void rotx()
{
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			for(int k=0;k<5;k++)
				bc[i][j][k]=ac[i][k][4-j];
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			for(int k=0;k<5;k++)
				ac[i][j][k]=bc[i][j][k];
}

void roty()
{
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			for(int k=0;k<5;k++)
				bc[i][j][k]=ac[4-k][j][i];
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			for(int k=0;k<5;k++)
				ac[i][j][k]=bc[i][j][k];
}

void rotz()
{
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			for(int k=0;k<5;k++)
				bc[i][j][k]=ac[j][4-i][k];
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			for(int k=0;k<5;k++)
				ac[i][j][k]=bc[i][j][k];
}

void up()
{
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			bc[i][4][j]=ac[4-j][4][i];
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			ac[i][4][j]=bc[i][4][j];
	bc[1][3][4]=ac[0][3][1];bc[2][3][4]=ac[0][3][2];bc[3][3][4]=ac[0][3][3];
	bc[4][3][3]=ac[1][3][4];bc[4][3][2]=ac[2][3][4];bc[4][3][1]=ac[3][3][4];
	bc[3][3][0]=ac[4][3][3];bc[2][3][0]=ac[4][3][2];bc[1][3][0]=ac[4][3][1];
	bc[0][3][1]=ac[3][3][0];bc[0][3][2]=ac[2][3][0];bc[0][3][3]=ac[1][3][0];
	for(int i=0;i<5;i++)
		for(int j=0;j<5;j++)
			ac[i][3][j]=bc[i][3][j];
}

void write()
{
	for(int i=0;i<3;i++) printf("   %c%c%c\n",ac[1][4][1+i],ac[2][4][1+i],ac[3][4][1+i]);
	for(int i=0;i<3;i++) printf("%c%c%c%c%c%c%c%c%c%c%c%c\n",
		ac[0][3-i][1],ac[0][3-i][2],ac[0][3-i][3],ac[1][3-i][4],ac[2][3-i][4],ac[3][3-i][4],
		ac[4][3-i][3],ac[4][3-i][2],ac[4][3-i][1],ac[3][3-i][0],ac[2][3-i][0],ac[1][3-i][0]);
	for(int i=0;i<3;i++)
	{
		printf("   %c%c%c\n",ac[1][0][3-i],ac[2][0][3-i],ac[3][0][3-i]);
	}
}

void read()
{
	char w[16];
	for(int i=0;i<3;i++) {scanf("%s",w);ac[1][4][1+i]=w[0];ac[2][4][1+i]=w[1];ac[3][4][1+i]=w[2];}
	for(int i=0;i<3;i++)
	{
		scanf("%s",w);
		ac[0][3-i][1]=w[0];ac[0][3-i][2]=w[1];ac[0][3-i][3]=w[2];
		ac[1][3-i][4]=w[3];ac[2][3-i][4]=w[4];ac[3][3-i][4]=w[5];
		ac[4][3-i][3]=w[6];ac[4][3-i][2]=w[7];ac[4][3-i][1]=w[8];
		ac[3][3-i][0]=w[9];ac[2][3-i][0]=w[10];ac[1][3-i][0]=w[11];
	}
	for(int i=0;i<3;i++)
	{
		scanf("%s",w);
		ac[1][0][3-i]=w[0];ac[2][0][3-i]=w[1];ac[3][0][3-i]=w[2];
	}
	string s;
	cin>>s;
	int len=s.length();
	for(int i=0;i<len;i++)
	{
		if(s[i]=='x') rotx();
		if(s[i]=='y') roty();
		if(s[i]=='z') rotz();
		if(s[i]>='1'&&s[i]<='3')
		{
			char num=s[i];
			for(char i='1';i<=num;i++) up();
		}
	}
}



int main()
{
	read();
	write();
	return 0;
}
