#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

struct garland
{
 int begin,end;
 garland() {};
 garland(int _begin,int _end) {begin=_begin;end=_end;}
};

bool comp(const garland &a,const garland &b)
{ return a.begin<b.begin || (a.begin==b.begin && a.end>b.end); }

int n;
int idt[200050];

void add(int pos,int val)
{ for(;pos<=n;pos+=pos&(-pos))
      idt[pos]+=val;
}

int srch(int pos)
{
 int res=0;
 for(;pos>0;pos-=pos&(-pos))
     res+=idt[pos];
 return res;
}

int main()
{
 int m,i,u,v;
 vector<garland> A;
 
 scanf("%d %d",&n,&m);
 for(i=0;i<m;i++)
    { scanf("%d %d",&u,&v);
      A.push_back(garland(u,v));
      A.push_back(garland(v,u));
    }
 sort(A.begin(),A.end(),comp);
 
 
 m=2*m;
 long long int res=0;
 
 for(i=0;i<m;i++)
 {
  if(A[i].begin<A[i].end) add(A[i].begin,1);
  else {
        add(A[i].end,-1);
        res+=srch(A[i].begin-1)-srch(A[i].end);
       }       
 }   
 
 cout<<res<<endl;

 return 0;
}
