#include <cstdio>
#include <algorithm>
using namespace std;

#define LB(x) ((x)&(-x))

const int MAXN = 1 << 18;

struct el {
	int l , r;
	
	void read() {
		scanf ("%d%d",&l,&r);
	}
};

int n , m;
el a[MAXN];
long long it[MAXN];

void read() {
	int i;
	
	scanf ("%d%d",&n,&m);
	for (i=1;i<=m;i++) 
		a[i].read();
}

long long ask ( int x ) {
	long long ans = 0;
	
	for (;x>0;x-=LB(x))
		ans += it[x];
	
	return ans;
}

void ins ( int x ) {
	for (;x<=n;x+=LB(x))
		++ it[x];
}

int cmp ( el a , el b ) {
	if ( a.l == b.l ) return a.r < b.r;
	return a.l < b.l;
}

void solve() {
	long long ans = 0;
	int i , j;
	
	sort ( a + 1 , a + m + 1 , cmp );
	
	for (i=1;i<=m;i++) {
		ans += ask ( a[i].r - 1 ) - ask ( a[i].l );
		
		if ( i != m && a[i].l != a[i + 1].l ) 
			for (j=i;j>=1;j--) {
				ins ( a[j].r );
				if ( a[j].l != a[j - 1].l ) 
					break;
			}
	}
	
	printf ("%lld\n",ans);
}

int main() {
	read();
	solve();
	
	return 0;
}
