#include <cstdio>
#include <cstdlib>
#include <iostream>
#define maxN 250000

using namespace std;

typedef struct baa {
        int a,b;
        } baa;

int n,m;
long long res;
int tree[maxN];
baa list[maxN];

int cmp(const void *a, const void *b)
{
    if ((*(baa*)a).b == (*(baa*)b).b)
       return (*(baa*)a).a - (*(baa*)b).a;
    else return (*(baa*)a).b - (*(baa*)b).b;
}

void push(int v, int p)
{
     while (p<=n) {
           tree[p] += v;
           p += (p&(-p));
           }
}

long long pop(int p)
{
    long long r=0;
    while (p>0) {
          r += tree[p];
          p -= (p&(-p));
          }
    return r;
}

int main()
{
    int a,b,t,i,j,k;
    scanf("%d%d",&n,&m);
    for (i=0;i<m;++i) {
        scanf("%d%d",&a,&b);
        if (a>b) {t=a;a=b;b=t;}
        list[i].a = a;
        list[i].b = b;
        }
    qsort(list,m,sizeof(baa),cmp);
    for (i=0;i<m;) {
        j = i; while (list[i].a == list[j].a && j < m) ++j; --j;
        for (k=i;k<=j;++k) res += (pop(list[k].b-1)-pop(list[k].a));
        for (k=i;k<=j;++k) {
            push(-1,list[k].a);
            push(+1,list[k].b);
            }
        i = j+1;
        }
    cout << res << "\n";
    return 0;
}
