#include <cstdio>
#include <queue>
#include <set>
#include <algorithm>

#define ull unsigned long long

using namespace std;

int N, K;
int a[1024];

void input() {
	scanf("%d%d", &N, &K);
	for(int i = 0; i < K; ++i) scanf("%d", a+i);
	sort(a, a+K, less<int>());
}

set<ull> res;

void solve() {
	int cur = 0;
	res.insert(0);
	ull cel, nel, limit = (ull)-1;
	while(1) {
		cel = *res.begin();
		res.erase(*res.begin());
		
		if(cur == N) {
			printf("%llu\n", cel);
			return;
		}
		
		for(int i = 0; i < K; ++i) {
			nel = cel+a[i];
			
			if(limit != (ull)-1 && nel > limit) break;
			
			if(res.find(nel) == res.end()) {
				res.insert(nel);
				if(res.size() > N+2) {
					limit = *--res.end();
					res.erase(--res.end());
				}
			}
		}
		
		++cur;
	}
}

int main() {
	input();
	solve();
	return 0;
}
