#include <cstdio>
#include <string>

using namespace std;

struct side {
	char data[4][4];
	
	side() {}
	
	char* operator[] (int index) {
		return data[index];
	}
};

void mstrncpy(char* dst, char* src, int n) {
	for(int i = 0; i < n; ++i) {
		*dst = *src;
		++dst;
		++src;
	}
	*dst = 0;
}

struct cube {
	side data[8];
	
	void rotate(string pattern) {
		side old_data[6];
		memcpy(old_data, data, sizeof(data));
		for(int i = 0; i < 6; ++i) data[i] = old_data[pattern[i]-'0'];
	}
	void rotatex() {
		rotate("415320");
	}
	
	void read() {
		char buff[16];
		for(int i = 0; i < 3; ++i)
			scanf("%s", data[4].data[i]);
		for(int i = 0; i < 3; ++i) {
			scanf("%s", buff);
			printf("%s\n", buff);
			mstrncpy(data[3][i], buff, 3);
			mstrncpy(data[0][i], buff+3, 3);
			mstrncpy(data[1][i], buff+6, 3);
			mstrncpy(data[2][i], buff+9, 3);
		}
		for(int i = 0; i < 3; ++i)
			scanf("%s", data[5].data[i]);
	}
	
	void write() {
		for(int i = 0; i < 3; ++i)
			printf("   %s\n", data[4][i]);
		for(int i = 0; i < 3; ++i)
			printf("%s%s%s%s\n", data[3][i], data[0][i], data[1][i], data[2][i]);
		for(int i = 0; i < 3; ++i)
			printf("   %s\n", data[5][i]);
	}
};

int main() {
	cube mc;
	mc.read();
	
	mc.write();
	return 0;
}
