#include <cstdio>
#include <vector>

int N, M;
int sz = 1;
int res;
int BIT[262145];
std :: vector<int> v[200005];

void update(int x, int a)
{
	for(; x <= sz; x += x & -x)
		BIT[x] += a;
}

int query(int x)
{
	int res = 0;
	for(; x > 0; x ^= x & -x)
		res += BIT[x];
	return res;
}

int query(int x, int y)
{
	return query(y) - query(x - 1);
}

int main()
{
    scanf("%d %d", &N, &M);
    while(sz < N)  sz <<= 1;
    for(int i = 0; i < M; i ++)
    {
		int p, q;
		scanf("%d %d", &p, &q);
		if( p > q )	std :: swap(p, q);
		v[p].push_back(q);
	}
	for(int i = 1; i <= N; i ++)
	{
		for(int j = 0; j < v[i].size(); j ++)
			res += query( i + 1, v[i][j] - 1 );
		for(int j = 0; j < v[i].size(); j ++)
			update(v[i][j], 1);
	}
	printf("%d\n", res);
    return 0;
}
