#include <cstdio>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 17;

struct Cmp {
	bool operator () ( int a , int b ) {
		return a > b;
	}
};

int n , k;
int a[MAXN];
set < int > st;
priority_queue < int , vector < int > , Cmp > pq;

void read() {
	int i;
	
	scanf ("%d%d",&n,&k);
	for (i=1;i<=k;i++)
		scanf ("%d",&a[i]);
}

void solve() {
	int i;
	int x;
	
	st.insert ( 0 );
	
	while ( n -- ) {
		x = *st.begin();
		st.erase ( st.begin() );
		
		for (i=1;i<=k;i++)
			st.insert ( x + a[i] );
	}
	
	printf ("%d\n",*st.begin());
}

void solve2() {
	int i;
	int x;
	int last = -1;
	
	pq.push ( 0 );
	
	while ( n -- ) {
		x = pq.top();
		pq.pop();
		
		if ( x == last ) {
			++ n;
			continue;
		}
		last = x;
		
		for (i=1;i<=k;i++)
			pq.push ( x + a[i] );
	}
	
	printf ("%d\n",pq.top());
}

int main() {
	read();
	solve();

	return 0;
}
